/************************************************************************
* ļ:Driver.cpp                                                 
*     :ŷǰ
* ѧϰ  :
* ڶѧϰʱ:2011.6.29
* 뻷:WDK7600.16385.1
* :עFlags  ֻһܶطԼ
*************************************************************************/

#include "Driver.h"

/************************************************************************
* :DriverEntry
* :ʼ򣬶λӲԴں˶
* б:
      pDriverObject:I/Oд
      pRegistryPath:עе·
*  ֵ:سʼ״̬
*************************************************************************/
//const WCHAR NameBuffer[] = L"\\Device\\CMOSDEVICE";
//const WCHAR DOSNameBuffer[] =L"\\??\\CMOS";
#pragma INITCODE
extern "C" NTSTATUS DriverEntry (
			IN PDRIVER_OBJECT pDriverObject,
			IN PUNICODE_STRING pRegistryPath	) 
{
	NTSTATUS status;
	KdPrint(("Enter DriverEntry\n"));

	//жغ
	pDriverObject->DriverUnload = CMOSUnload;

	//ǲ
	for (int i = 0; i < arraysize(pDriverObject->MajorFunction); ++i)
		pDriverObject->MajorFunction[i] = CMOSDispatchRoutine;  

	pDriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL] = CMOSDeviceIOControl;
	//ֻIRP_MJ_DEVICE_CONTROLϢȤ ֻ ļ򵥵ķسɹ
	
	//豸
	status = CreateDevice(pDriverObject);

	KdPrint(("Leave DriverEntry\n"));
	return status;
}

/************************************************************************
* :CreateDevice
* :ʼ豸
* б:
      pDriverObject:I/Oд
*  ֵ:سʼ״̬
*************************************************************************/
#pragma INITCODE
NTSTATUS CreateDevice (
		IN PDRIVER_OBJECT	pDriverObject) 
{
	NTSTATUS status;
	PDEVICE_OBJECT pDeviceObject;
//	PDEVICE_EXTENSION pDevExt;
	
	//豸
	UNICODE_STRING DeviceName;
	RtlInitUnicodeString(&DeviceName,L"\\Device\\CMOSDEVICE");
	
	//豸
	status = IoCreateDevice( pDriverObject,
						0,//ֻдһܼ򵥵СûõDEVICE_EXTENSIONõ sizeof(DEVICE_EXTENSION),
						&(UNICODE_STRING)DeviceName,
						FILE_DEVICE_UNKNOWN,
						0, 
						TRUE,//trueĻ˵Ƕռ豸
						&pDeviceObject//ܷص豸ָ
						);
	if (!NT_SUCCESS(status))
		return status;

	pDeviceObject->Flags |= DO_DIRECT_IO;
//	pDevExt = (PDEVICE_EXTENSION)pDevObj->DeviceExtension;
//	pDevExt->pDevice = pDevObj;
//	pDevExt->ustrDeviceName = devName;



	//
	UNICODE_STRING SymbolicLinkName;
	RtlInitUnicodeString(&SymbolicLinkName,L"\\??\\CMOS");
//	pDevExt->ustrSymLinkName = symLinkName;
	status = IoCreateSymbolicLink( &SymbolicLinkName,&DeviceName );
	if (!NT_SUCCESS(status)) 
	{
		//ע һ ǶԵ  Ƕ һĻӦðе豸ɾ 豸Ȼɾ
		IoDeleteDevice( pDeviceObject );
		return status;
	}
	return STATUS_SUCCESS;
}

/************************************************************************
* :CMOSUnload
* :жز
* б:
      pDriverObject:
*  ֵ:״̬
*************************************************************************/
#pragma PAGEDCODE
VOID CMOSUnload (IN PDRIVER_OBJECT pDriverObject) 
{
	
/*	PDEVICE_OBJECT	pNextObj;
	KdPrint(("Enter CMOSUnload\n"));
	pNextObj = pDriverObject->DeviceObject;
	while (pNextObj != NULL) 
	{
		PDEVICE_EXTENSION pDevExt = (PDEVICE_EXTENSION)pNextObj->DeviceExtension;  
		//ɾ
		UNICODE_STRING pLinkName = pDevExt->ustrSymLinkName;
		IoDeleteSymbolicLink(&pLinkName);
		pNextObj = pNextObj->NextDevice;
		IoDeleteDevice( pDevExt->pDevice );
	}  */
	/*Ϊǵܼ óƪ۵ж ֱӵ
	IoDeleteSymbolicLink 
    IoDeleteDevice ɾ*/
	UNICODE_STRING SymbolicLinkName;//Ҫ  1linkerror
	RtlInitUnicodeString(&SymbolicLinkName,L"\\??\\CMOS");
	KdPrint(("Enter CMOSUnload\n"));
	IoDeleteSymbolicLink(&SymbolicLinkName);
	IoDeleteDevice(pDriverObject->DeviceObject);

}

/************************************************************************
* :CMOSDispatchRoutin  CMOSDeviceIOControl   ֻIRP_MJ_DEVICE_CONTROLϢȤ ֻ ļ򵥵ķسɹ
* :ԶIRPд
* б:
      pDevObj:豸
      pIrp:IO
*  ֵ:״̬
*************************************************************************/

#pragma PAGEDCODE
NTSTATUS CMOSDispatchRoutine(IN PDEVICE_OBJECT pDeviceObject,
								 IN PIRP pIrp) 
{
	KdPrint(("Enter CMOSDispatchRoutine\n"));
	NTSTATUS status = STATUS_SUCCESS;
	// IRP
	pIrp->IoStatus.Status = status;
	pIrp->IoStatus.Information = 0;	// bytes xfered
	IoCompleteRequest( pIrp, IO_NO_INCREMENT );

	KdPrint(("Leave CMOSDispatchRoutine\n"));

	return status;
} 



#pragma PAGEDCODE
NTSTATUS CMOSDeviceIOControl(IN PDEVICE_OBJECT pDeviceObject,
								 IN PIRP pIrp)
{
	NTSTATUS status = STATUS_SUCCESS;
	KdPrint(("Enter CMOSDeviceIOControl\n"));

	//õǰջ
	PIO_STACK_LOCATION stack = IoGetCurrentIrpStackLocation(pIrp);
	//õ뻺С
	ULONG cbin = stack->Parameters.DeviceIoControl.InputBufferLength;
	//õС
	ULONG cbout = stack->Parameters.DeviceIoControl.OutputBufferLength;
	//õIOCTL
	ULONG code = stack->Parameters.DeviceIoControl.IoControlCode;

	ULONG info = 0;

	switch (code)
	{						// process request
		case READ_PORT:
		{
			KdPrint(("READ_PORT\n"));
			//ʽIOCTL
			//ʾ뻺
 			PULONG InputBuffer = (PULONG)pIrp->AssociatedIrp.SystemBuffer;
			ULONG port = (ULONG)(*InputBuffer);
			InputBuffer++;
			UCHAR method = (UCHAR)(*InputBuffer);

			//
			PULONG OutputBuffer = (PULONG)pIrp->AssociatedIrp.SystemBuffer;
			/*С
			Ĳһַָ룬ôֻѰַIO0x00-0xff, 
Ҫ0x03f8ô 
ULONG   nPort   =   0x3f8; 
UCHAR   Val   =   READ_PORT_UCHAR((PUCHAR)nPort);
			*/

			if (method==1)//8λ
			{
				*OutputBuffer = READ_PORT_UCHAR((PUCHAR)port);
			}else if(method==2)//16λ
			{
				*OutputBuffer = READ_PORT_USHORT((PUSHORT)port);
			}else if(method==4)//32λ
			{
				*OutputBuffer = READ_PORT_ULONG((PULONG)port);
			}

			//ʵʲ
 			info = 4;

			break;
		}
		case WRITE_PORT:
		{
			KdPrint(("WRITE_PORT\n"));
			//ʽIOCTL
			//ʾ뻺
 			PULONG InputBuffer = (PULONG)pIrp->AssociatedIrp.SystemBuffer;
			ULONG port = (ULONG)(*InputBuffer);
			InputBuffer++;
			UCHAR method = (UCHAR)(*InputBuffer);
			InputBuffer++;
			ULONG value = (ULONG)(*InputBuffer);

			//
			PULONG OutputBuffer = (PULONG)pIrp->AssociatedIrp.SystemBuffer;

			if (method==1)//8λ
			{
				WRITE_PORT_UCHAR((PUCHAR)port,(UCHAR)value);
			}else if(method==2)//16λ
			{
				WRITE_PORT_USHORT((PUSHORT)port,(USHORT)value);
			}else if(method==4)//32λ
			{
				WRITE_PORT_ULONG((PULONG)port,(ULONG)value);
			}

			//ʵʲ
 			info = 0;
			break;
		}


		default:
			status = STATUS_INVALID_VARIANT;
	}

	// IRP
	pIrp->IoStatus.Status = status;
	pIrp->IoStatus.Information = info;	// bytes xfered
	IoCompleteRequest( pIrp, IO_NO_INCREMENT );

	KdPrint(("Leave HelloDDKDeviceIOControl\n"));

	return status;
}