/************************************************************************
* ļ:CMOSASM.cpp  ʺ汾                                             
*     :ŷǰ
* ѧϰ  
* ѧϰ:2011-06-30
*************************************************************************/

#include "CMOSASM.h"

/************************************************************************
* :DriverEntry
* :ʼ򣬶λӲԴں˶
* б:
      pDriverObject:I/Oд
      pRegistryPath:עе·
*  ֵ:سʼ״̬
*************************************************************************/
#pragma INITCODE
extern "C" NTSTATUS DriverEntry (
			IN PDRIVER_OBJECT pDriverObject,
			IN PUNICODE_STRING pRegistryPath	) 
{
	NTSTATUS status;
	KdPrint(("Enter DriverEntry\n"));

	//жغ
	pDriverObject->DriverUnload = CMOSASMUnload;

	//ǲ
	for (int i = 0; i < arraysize(pDriverObject->MajorFunction); ++i)
		pDriverObject->MajorFunction[i] = CMOSASMDispatchRoutin;
	//ֻǸȤDeviceIoControl ļ򵥵ķسɹ

	pDriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL] = CMOSASMDeviceIOControl;
	
	//豸
	status = CreateDevice(pDriverObject);

	KdPrint(("Leave DriverEntry\n"));
	return status;
}

/************************************************************************
* :CreateDevice
* :ʼ豸
* б:
      pDriverObject:I/Oд
*  ֵ:سʼ״̬
*************************************************************************/
#pragma INITCODE
NTSTATUS CreateDevice (
		IN PDRIVER_OBJECT	pDriverObject) 
{
	NTSTATUS status;
	PDEVICE_OBJECT pDeviceObject;
//	PDEVICE_EXTENSION pDevExt;
	
	//豸
	UNICODE_STRING DeviceName;
	RtlInitUnicodeString(&DeviceName,L"\\Device\\CMOSASMDevice");
	
	//豸
	status = IoCreateDevice( pDriverObject,
						0,//ΪûõDEVICE_EXTENSIONֱ0  õĻsizeof(DEVICE_EXTENSION),
						&(UNICODE_STRING)DeviceName,
						FILE_DEVICE_UNKNOWN,
						0, 
						TRUE,//Ƕռ豸
						&pDeviceObject );
	if (!NT_SUCCESS(status))
		return status;

	pDeviceObject->Flags |= DO_DIRECT_IO;
//	pDevExt = (PDEVICE_EXTENSION)pDevObj->DeviceExtension;
//	pDevExt->pDevice = pDevObj;
//	pDevExt->ustrDeviceName = devName;

	//ģļĻ
//	pDevExt->buffer = (PUCHAR)ExAllocatePool(PagedPool,MAX_FILE_LENGTH);
	//ģļС
//	pDevExt->file_length = 0;

	//
	UNICODE_STRING SymbolicLinkName;
	RtlInitUnicodeString(&SymbolicLinkName,L"\\??\\CMOSASM");
//	pDevExt->ustrSymLinkName = symLinkName;
	status = IoCreateSymbolicLink( &SymbolicLinkName,&DeviceName );
	if (!NT_SUCCESS(status)) 
	{
		IoDeleteDevice( pDeviceObject );
		return status;
	}
	return STATUS_SUCCESS;
}

/************************************************************************
* :CMOSASMUnload
* :жز
* б:
      pDriverObject:
*  ֵ:״̬
*************************************************************************/
#pragma PAGEDCODE
VOID CMOSASMUnload (IN PDRIVER_OBJECT pDriverObject) 
{
/*	PDEVICE_OBJECT	pNextObj;
	KdPrint(("Enter DriverUnload\n"));
	pNextObj = pDriverObject->DeviceObject;
	while (pNextObj != NULL) 
	{
		PDEVICE_EXTENSION pDevExt = (PDEVICE_EXTENSION)
			pNextObj->DeviceExtension;
		if (pDevExt->buffer)
		{
			ExFreePool(pDevExt->buffer);
			pDevExt->buffer = NULL;
		}

		//ɾ
		UNICODE_STRING pLinkName = pDevExt->ustrSymLinkName;
		IoDeleteSymbolicLink(&pLinkName);
		pNextObj = pNextObj->NextDevice;
		IoDeleteDevice( pDevExt->pDevice );
	} */
		/*Ϊǵܼ óƪ۵ж ֱӵ
	IoDeleteSymbolicLink 
    IoDeleteDevice ɾ*/
	UNICODE_STRING SymbolicLinkName;//Ҫ  1linkerror
	RtlInitUnicodeString(&SymbolicLinkName,L"\\??\\CMOSASM");//Ҫһɵǳʼ  2linkerror
	KdPrint(("Enter CMOSUnload\n"));
	IoDeleteSymbolicLink(&SymbolicLinkName);
	IoDeleteDevice(pDriverObject->DeviceObject);
}

/************************************************************************
* :CMOSASMDispatchRoutin
* :ԶIRPд
* б:
      pDeviceObject:豸
      pIrp:IO
*  ֵ:״̬
*************************************************************************/
#pragma PAGEDCODE
NTSTATUS CMOSASMDispatchRoutin(IN PDEVICE_OBJECT pDeviceObject,
								 IN PIRP pIrp) 
{
	KdPrint(("Enter CMOSASMDispatchRoutin\n"));


	NTSTATUS status = STATUS_SUCCESS;
	// IRP
	pIrp->IoStatus.Status = status;
	pIrp->IoStatus.Information = 0;	// bytes xfered
	IoCompleteRequest( pIrp, IO_NO_INCREMENT );

	KdPrint(("Leave CMOSASMDispatchRoutin\n"));

	return status;
}

#pragma PAGEDCODE
UCHAR In_8 (PUCHAR Port)
{
   UCHAR Value;
	__asm
	{
		//IN Ϊ OUTΪд    ֻҪסIN OUTCPUļĴ˵ľͺü
		mov edx, Port   //˿ںŶedx
		in al, dx       //Ӷ˿ں(dx)ֵŵal
		mov Value, al   //alеֵŵvalue
		//뼸ָ
		nop
		nop
	}

   return(Value);
}

USHORT In_16 (PUSHORT Port)
{
   USHORT Value;

	__asm
	{
		mov edx, Port
		in ax, dx
		mov Value, ax
		//뼸ָ
		nop
		nop
	}
   return(Value);
}

ULONG In_32 (PULONG Port)
{
   ULONG Value;
	__asm
	{
		mov edx, Port
		in eax, dx
		mov Value, eax
		//뼸ָ
		nop
		nop
	}
   return(Value);
}

void Out_32(PULONG Port,ULONG Value)
{
	__asm
	{
		mov edx, Port  //˿ںŷŵedx
		mov eax, Value //Ҫд˿ڵֵŵeax
		out dx,eax     //ֵд˿
		//뼸ָ
		nop
		nop
	}
}
void Out_16 (PUSHORT Port,USHORT Value)
{
	__asm
	{
		mov edx, Port
		mov ax, Value
		out dx,ax
		//뼸ָ
		nop
		nop
	}
}

void Out_8 (PUCHAR Port,UCHAR Value)
{
	__asm
	{
		mov edx, Port
		mov al, Value
		out dx,al
		//뼸ָ
		nop
		nop
	}
}
#pragma PAGEDCODE
NTSTATUS CMOSASMDeviceIOControl(IN PDEVICE_OBJECT pDeviceObject,
								 IN PIRP pIrp)
{
	NTSTATUS status = STATUS_SUCCESS;
	KdPrint(("Enter CMOSASMDeviceIOControl\n"));

	//õǰջ
	PIO_STACK_LOCATION stack = IoGetCurrentIrpStackLocation(pIrp);
	//õ뻺С
	ULONG cbin = stack->Parameters.DeviceIoControl.InputBufferLength;
	//õС
	ULONG cbout = stack->Parameters.DeviceIoControl.OutputBufferLength;
	//õIOCTL
	ULONG code = stack->Parameters.DeviceIoControl.IoControlCode;

	ULONG info = 0;

	switch (code)
	{						// process request
		case READ_PORT:
		{
			KdPrint(("READ_PORT\n"));
			//ʽIOCTL
			//ʾ뻺
			//עInputBuffer READ_PORTʱ2Ԫ WRITE_PORTʱ3Ԫ
 			PULONG InputBuffer = (PULONG)pIrp->AssociatedIrp.SystemBuffer;
			ULONG port = (ULONG)(*InputBuffer);
			InputBuffer++;
			UCHAR method = (UCHAR)(*InputBuffer);

			//
			PULONG OutputBuffer = (PULONG)pIrp->AssociatedIrp.SystemBuffer;

			if (method==1)//8λ
			{
				*OutputBuffer = In_8((PUCHAR)port);
			}else if(method==2)//16λ
			{
				*OutputBuffer = In_16((PUSHORT)port);
			}else if(method==4)//32λ
			{
				*OutputBuffer = In_32((PULONG)port);
			}

			//ʵʲ
 			info = 4;   //ΪʲôҪó4 cbout治  ûԹ Ҳ֪Ϊʲô  ӳ

			break;
		}
		case WRITE_PORT:
		{
			KdPrint(("WRITE_PORT\n"));
			//ʽIOCTL
			//ʾ뻺
 			PULONG InputBuffer = (PULONG)pIrp->AssociatedIrp.SystemBuffer;
			ULONG port = (ULONG)(*InputBuffer);
			InputBuffer++;
			UCHAR value = (UCHAR)(*InputBuffer);
			InputBuffer++;
			ULONG method = (ULONG)(*InputBuffer);

			//
			PULONG OutputBuffer = (PULONG)pIrp->AssociatedIrp.SystemBuffer;

			if (method==1)//8λ
			{
				Out_8((PUCHAR)port,(UCHAR)value);
			}else if(method==2)//16λ
			{
				Out_16((PUSHORT)port,(USHORT)value);
			}else if(method==4)//32λ
			{
				Out_32((PULONG)port,(ULONG)value);
			}

			//ʵʲ
 			info = 0;
			break;
		}
		default:
			status = STATUS_INVALID_VARIANT;
	}

	// IRP
	pIrp->IoStatus.Status = status;
	pIrp->IoStatus.Information = info;	// bytes xfered
	IoCompleteRequest( pIrp, IO_NO_INCREMENT );

	KdPrint(("Leave CMOSASMDeviceIOControl\n"));

	return status;
}